#!/bin/bash

# author          : Lontronics, http://www.lontronics.nl
# maintainer      : Lontronics
# source location : http://labs.adobe.com/downloads
# latest update   : 31-jan-2007

script=build-flash_plugin.sh

srcname=install_flash_player_7_linux     # source package name
dirname=install_flash_player_7_linux     # directory when uncompressed
pkgname=flash_plugin-7.0.69.0            # name of package to build

#srcname=install_flash_player_9_linux      # source package name
#dirname=install_flash_player_9_linux      # directory when uncompressed
#pkgname=flash_plugin-9.0.31.0             # name of package to build

build=44.1

#############################

org=$(pwd)
pkg=/tmp/pkg-$pkgname
src=/tmp/$dirname
dst=/data/software/_builds

package=$pkgname-i686-$build
buildlog=$dst/$package.log

prefix=/usr

#############################

cd /tmp

rm -f $buildlog
touch $buildlog

rm -rf $src 2> /dev/null
rm -rf $pkg 2> /dev/null

mkdir -p $pkg/install
mkdir -p $pkg/$prefix/doc/$pkgname
mkdir -p $pkg/$prefix/lib/mozilla/plugins
mkdir -p $pkg/$prefix/src/$pkgname


cat << EOF >> $buildlog

Logfile for package $package.tgz

Compiled        : $(date)
Author          : Lontronics, http://www.lontronics.nl
EOF


echo "decompress sources..."

cat << EOF >> $buildlog

---- decompress source package ----

EOF

if [ -f $org/$srcname.tar.gz ]; then tar zxvf $org/$srcname.tar.gz >> $buildlog 2>&1 || exit 1;
elif [ -f $org/$srcname.tgz ]; then tar zxvf $org/$srcname.tgz >> $buildlog 2>&1 || exit 1;
elif [ -f $org/$srcname.tar.bz2 ]; then tar jxvf $org/$srcname.tar.bz2 >> $buildlog 2>&1 || exit 1;
elif [ -f $org/$srcname.zip ]; then unzip -o $org/$srcname.zip >> $buildlog 2>&1 || exit 1; fi

cd $src

chown -R root.root .

find . -type d -exec chmod 755 {} \;
find . -perm 777 -exec chmod 755 {} \;
find . -perm 775 -exec chmod 755 {} \;
find . -perm 711 -exec chmod 755 {} \;
find . -perm 555 -exec chmod 755 {} \;
find . -perm 511 -exec chmod 755 {} \;
find . -perm 664 -exec chmod 644 {} \;
find . -perm 600 -exec chmod 644 {} \;
find . -perm 444 -exec chmod 644 {} \;
find . -perm 440 -exec chmod 644 {} \;
find . -perm 400 -exec chmod 644 {} \;


cat << EOF > $pkg/install/slack-desc
            |-----handy-ruler------------------------------------------------------|
flash_plugin: flash_plugin (Macromedia Flash Player plugin)
flash_plugin: 
flash_plugin: FLASH 7 IS RECOMMENDED FOR OPERA.
flash_plugin: FLASH 9 IS RECOMMENDED FOR OTHER BROWSERS.
flash_plugin:
flash_plugin: Flash-player-plugin package, using $prefix/lib/mozilla as directory.
flash_plugin: Be sure this directory is used as your plugin directory.
flash_plugin: If there, the plugin is also linked to $prefix/lib/firefox/plugins,
flash_plugin: so Firefox will also find the Flash plugin.
flash_plugin: 
flash_plugin: Package created for Zenwalk
EOF


cat << EOF > $pkg/install/doinst.sh
if [ -d "$prefix/lib/firefox" ]; then
  mkdir -p $prefix/lib/firefox/plugins
  ln -fs $prefix/lib/mozilla/plugins/libflashplayer.so $prefix/lib/firefox/plugins/
  if [ -f "$prefix/lib/mozilla/plugins/flashplayer.xpt" ]; then
    ln -fs $prefix/lib/mozilla/plugins/flashplayer.xpt $prefix/lib/firefox/plugins/
  fi
fi
EOF
chmod 755 $pkg/install/doinst.sh


cp -f $src/libflashplayer.so $pkg/$prefix/lib/mozilla/plugins

if [ -f "$src/flashplayer.xpt" ]; then
  cp -f $src/flashplayer.xpt $pkg/$prefix/lib/mozilla/plugins
fi

if [ -f "$src/Readme.txt" ]; then
  cp -f $src/Readme.txt $pkg/$prefix/doc/$pkgname
fi

if [ -f "$src/readme.txt" ]; then
  cp -f $src/readme.txt $pkg/$prefix/doc/$pkgname
fi

cp $org/$script $pkg/$prefix/src/$pkgname/$script


cd $pkg

find . | xargs file | grep "current ar archive" | cut -f 1 -d : | xargs strip --strip-debug 2> /dev/null
find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null


echo "makepkg..."

cat << EOF >> $buildlog

---- makepkg ----

EOF

makepkg -l y -c n /tmp/$package.tgz >> $buildlog 2>&1 || exit 1

if [ -f /tmp/$package.tgz ]; then
  mv /tmp/$package.tgz $dst/
  cd $dst
  echo "making md5sum..."
  md5sum $package.tgz > $package.md5
  echo "making dependency file..."
  requiredbuilder -z $dst/$package.tgz > $dst/$package.dep
  cp $org/$script $dst/$script
fi


echo "cleaning up..."
cd /tmp
rm -rf $pkg 2> /dev/null
rm -rf $src 2> /dev/null
rm -rf /tmp/requiredbuilder 2> /dev/null

echo "done"
## EOF ##